<%
Class CDatesTime
    Private m_String
    
    Private Sub Class_Initialize
        Set m_String = Nothing
    End Sub
    
    Private Sub Class_Terminate
        Set m_String = Nothing
    End Sub
    
    Public Default Property Get DefaultProperty
        DefaultProperty = typename(Me) & "<span style=""color: red"">***Debuging***</span>"
    End Property

    ' pour dcoder un nombre de ms en h, m, s, ms
    ' s'utilise avec timer() : DecodeMilliSecondTimer(timerStop-timerStart)
    '+-------------------------------------------------------
    Public Function DecodeMilliSecondTimer(pMilliSecond)
        Dim intMilliSecond, intSecond, intMinute, intHour
        intMilliSecond = Int(pMilliSecond*1000) mod 1000
        intSecond = Int(pMilliSecond)
        intMinute = Int(intSecond / 60)
        intSecond = intSecond mod 60
        intHour = Int(intMinute / 60)
        intMinute = intMinute mod 60
        If intHour <> 0 Then DecodeMilliSecondTimer = intHour & "h " End If
        If intMinute <> 0 Then DecodeMilliSecondTimer = DecodeMilliSecondTimer & "min " End If
        If intSecond <> 0 Then DecodeMilliSecondTimer = DecodeMilliSecondTimer & intSecond & "s " End If
        If intMilliSecond <> 0 Then DecodeMilliSecondTimer = DecodeMilliSecondTimer & intMilliSecond & "ms " End If
    End Function
    
    ' obtention de la date du jour en DD/MM/YYYY
    '+-------------------------------------------------------
    Public Function GetTodayDDMMYYYY 
        Dim p_today_MM, p_today_DD, p_today_YYYY
        Dim lNumbers
        Set lNumbers = new CNumbers
        p_today_DD = lNumbers.to00(day(now))
        p_today_MM = lNumbers.to00(month(now))
        p_today_YYYY = year(now)
        GetTodayDDMMYYYY = p_today_DD & "/" & p_today_MM & "/" & p_today_YYYY
        Set lNumbers = nothing
    End Function

    ' formatage d'une date existante en DD/MM/YYYY
    '+-------------------------------------------------------
    Public Function FormatDateDDMMYYYY(pDate)
        Dim p_DD, p_MM, p_YYYY
        Dim lNumbers
        Set lNumbers = new CNumbers
        If Globals.DefaultValue(pDate, "") <> "" Then
            p_DD = lNumbers.to00(Day(pDate))
            p_MM = lNumbers.to00(Month(pDate))
            p_YYYY = Year(pDate)
            FormatDateDDMMYYYY = p_DD & "/" & p_MM & "/" & p_YYYY
        else
            FormatDateDDMMYYYY = ""
        End If
        Set lNumbers = nothing
    End Function
    
    ' pour passer de "mardi 08 juin 2005 00:00  08/06/2005"
    '+-------------------------------------------------------
    Public Function StringDateToDDMMYYYY(pDate)
        If Globals.DefaultValue(pDate, "") <> "" Then
            Dim pDate_splitted, pTemp
            pDate_splitted = split(pDate, " ")
            ' le jour
            pTemp = pDate_splitted(1) & "/"
            ' le mois
            select case lcase(pDate_splitted(2))
                case "janvier"
                    pTemp = pTemp & "01/"
                case "fevrier", "fvrier"
                    pTemp = pTemp & "02/"
                case "mars"
                    pTemp = pTemp & "03/"
                case "avril"
                    pTemp = pTemp & "04/"
                case "mai"
                    pTemp = pTemp & "05/"
                case "juin"
                    pTemp = pTemp & "06/"
                case "juillet"
                    pTemp = pTemp & "07/"
                case "aout", "aot"
                    pTemp = pTemp & "08/"
                case "septembre"
                    pTemp = pTemp & "09/"
                case "octobre"
                    pTemp = pTemp & "10/"
                case "novembre"
                    pTemp = pTemp & "11/"
                case "decembre", "dcembre"
                    pTemp = pTemp & "12/"
                case else
                    pTemp = pTemp & "00/"
            End select
            ' l'anne
            pTemp = pTemp & pDate_splitted(3)
            StringDateToDDMMYYYY = pTemp
        else
            StringDateToDDMMYYYY = ""
        End If
    End Function
    
    ' formatage pour l'affichage
    '+-------------------------------------------------------
    Public Function FormatDate(pDate)    'au format "01 janvier 2005"
        If Globals.DefaultValue(pDate, "") <> "" Then
            If isDate(pDate) Then
                FormatDate = FormatDateTime(pDate, 1)
            else
                FormatDate = ""
            End If
        else
            FormatDate = ""
        End If
    End Function
    
    ' formattage d'une heure en 21:30
    '+-------------------------------------------------------
    Public Function FormatTimeHHMM(pDate)
        Dim lNumbers
        Set lNumbers = new CNumbers
        Dim p_HH, p_MM
        If not IsNull(pDate) Then
            p_HH = lNumbers.to00(Hour(pDate))
            p_MM = lNumbers.to00(Minute(pDate))
            FormatTimeHHMM = p_HH & ":" & p_MM 
        else
            FormatTimeHHMM = ""
        End If
        Set lNumbers = nothing
    End Function

End Class
%>