<%

Class CDebug
    Private m_IsDebug
    Private m_IsDebugTbl
    Private m_Color
    Private m_THColor
    Private m_TDColor
    
    Private Sub Class_Initialize
        IsDebug = False
        IsDebugTbl = False
        Color = "#ff8c00"
        THColor = "#ff8c00"
        TDColor = "#ffd700"
        InitDebug
    End Sub
    
    Private Sub Class_Terminate

    End Sub
    
    Private Sub InitDebug
        if len(Session.Contents.Item("sql")) > 0 then
            IsDebug = true
        end if
        if len(Session.Contents.Item("rst")) > 0 then
            IsDebugTbl = true
        end if
    End Sub

    Public Default Property Get DefaultProperty
        DefaultProperty = typename(Me)
    End Property
    
    Public Property Let IsDebug(value)
        m_IsDebug = value
    End Property
    Public Property Get IsDebug
        IsDebug = m_IsDebug
    End Property
    
    Public Property Let IsDebugTbl(value)
        m_IsDebugTbl = value
    End Property
    Public Property Get IsDebugTbl
        IsDebugTbl = m_IsDebugTbl
    End Property
    
    Public Property Let Color(value)
        m_Color = value
    End Property
    Public Property Get Color
        Color = m_Color
    End Property
    
    Public Property Let THColor(value)
        m_THColor = value
    End Property
    Public Property Get THColor
        THColor = m_THColor
    End Property
    
    Public Property Let TDColor(value)
        m_TDColor = value
    End Property
    Public Property Get TDColor
        TDColor = m_TDColor
    End Property
    
    Public Function DWrite(value)
        If IsDebug Then
            Response.Write "<span style=""color: " & Color & "; font-size: 0.8em; font-weight: bold;"">" & value & "</span><br />" & vbcrlf
        End If
    End Function
    
    Public Sub RsToTable(rs)
        If IsDebugTbl Then
            Dim i, j
            j = 0
            response.Write("<table style=""background-color: orange; color: black; width:auto;"">" & vbcrlf)
            response.Write("<tr>" & vbcrlf)
            For i= 0 to rs.fields.count-1
                response.write ("<th style=""background-color: " & THColor & ";"">" & rs.fields(i).name & "&nbsp;</th>" & vbcrlf)
            Next 
            response.Write("</tr>" & vbcrlf)
            If not rs.eof Then
                Do while not rs.eof
                    response.Write("<tr>" & vbcrlf)
                    For i = 0 to rs.fields.count-1 
                        response.write ("<td style=""background-color: " & TDColor & ";"">" & rs.fields(i).value & "&nbsp;</td>" & vbcrlf)
                    Next 
                    response.Write("</tr>" & vbcrlf)
                    rs.movenext
                    j = j + 1
                    If j >= 10 Then
                        Response.Write("<tr><td colspan=""" & rs.fields.count & """ style=""background-color: " & THColor & ";"">Records nb &gt; 10</td></tr>")
                        Exit Do
                    End If
                loop
                rs.movefirst
            Else
                Response.Write("<tr><td colspan=""" & rs.fields.count & """ style=""background-color: " & THColor & ";"">No records</td></tr>")
            End If
            response.Write("</table>" & vbcrlf)
        End If
    End Sub

End Class

%>