<%
Class CForms
    
    Private m_DB
    
    Private Sub Class_Initialize
        Set m_DB = Nothing
    End Sub
    
    Private Sub Class_Terminate
        Set m_DB = Nothing
    End Sub
    
    Public Default Property Get DefaultProperty
        DefaultProperty = typename(Me)
    End Property
    
    Public Property Set BD(object)
        Set m_DB = object
    End Property
    Private Property Get BD
        Set BD = m_DB
    End Property
    
    Public Sub SqlToDDListe(sql, classname, selectedvalue, id)
        Call BD.RsToDDListe(BD.ExecuteQuery(sql), classname, selectedvalue, id)
    End Sub

    Public Sub RsToDDListe(rs, classname, selectedvalue, id)
        Call BD.RsToDDListe(rs, classname, selectedvalue, id)
    End Sub

    ' dterminer la taille des champs de formulaire
    '+-------------------------------------------------------
    Public Function SizeInput(pValue)
        If Instr(Request.servervariables("HTTP_USER_AGENT"),"MSIE") > 0 _
        or Instr(Request.servervariables("HTTP_USER_AGENT"),"Mozilla") > 0 Then
            SizeInput = pValue
        else
            SizeInput = pValue - 10
        End If
    End Function
    
    Public sub return_field_size(taille)
        response.write SizeInput(taille) 
    End sub 
    
    ' construction menu droulant  partir d'un RecordSet
    '+-------------------------------------------------------
    Public sub Combo (pRS, pName, pSelect, pTexte)
        'il faut que le RecordSet pRS soit format ainsi : id en pRS(0) et libell en pRS(1)
        If not pRS.EoF Then %>
            <select name="<%=pName%>"><%
            If pTexte <> "" Then %>
                <option value="0"><%=pTexte%></option><%
            End If
            do while not pRS.EoF %>
                <option value="<%=pRS(0)%>" <% If clng(pRS(0)) = clng(pSelect) Then Response.Write "selected" End If%>><%=pRS(1)%></option><%
                pRS.MoveNext
            Loop %>
            </select><%
        End If
    End sub
    
    ' construction menu droulant  partir d'un RecordSet avec submit sur le onChange
    '+-------------------------------------------------------
    Public sub ComboSubmit (pRS, pName, pSelect, pTexte, pForm)
        'il faut que le RecordSet pRS soit format ainsi : id en pRS(0) et libell en pRS(1)
        If pSelect = "" Then pSelect = 0 End If
        If not pRS.EoF Then %>
            <select name="<%=pName%>" onChange="document.<%=pForm%>.submit();"><%
            If pTexte <> "" Then %>
                <option value="0"><%=pTexte%></option><%
            End If
            do while not pRS.EoF %>
                <option value="<%=pRS(0)%>" <% If clng(pRS(0))=clng(pSelect) Then Response.Write "selected" End If%>><%=pRS(1)%></option><%
                pRS.MoveNext
            Loop %>
            </select><%
        End If
    End sub
    
    ' construire un input de type texte
    '+-------------------------------------------------------
    Public sub InputTexte (pName, pSize, pTexte)
        If Globals.DefaultValue(pName, "") <> "" Then
            If cLng(gNumbers.toZero(pSize)) = 0 Then
                pSize = 15
            End If %>
            <input type="texte" name="<%= pName%>" size="<%= SizeInput(pSize) %>" value="<%= pTexte%>"><%
        End If
    End sub
    
    ' construire un input de type textarea
    '+-------------------------------------------------------
    Public sub InputTextarea (pName, pCol, pRows, pTexte)
        If Globals.DefaultValue(pName, "") <> "" Then
            If cLng(pCol) = 0 Then
                pCol = 15
            End If
            If cLng(pRows) = 0 Then
                pRows = 3
            End If %>
            <textarea name="<%= pName%>" cols="<%= pCol%>" rows="<%= pRows%>"><%= pTexte%></textarea><%
        End If
    End sub
    
    ' champ date avec reformattage automatique
    '+-------------------------------------------------------
    Public sub DateField(name, pSize, value)
        Response.Write "<input name=""" & name & """ size="""& pSize &""" maxlength=""10"""
        If value <> "" Then
            Response.write " value=""" & FormatDateDDMMYYYY(value) & """"
        End If
        Response.Write " onblur=""" & _
            "If (this.form." & name & ".value!=''){var c=" & name & ".value;" & _
            "var b=new Date(c.substr(c.lastIndexOf('/')+1),parseInt(c.substring(c.indexOf('/')+1,c.lastIndexOf('/')),10)-1,c.substring(0,c.indexOf('/')));" & _
            "If(isNaN(b)){" & _
                "var a=new Date();" & _
            "}else{" & _
                "var a=new Date(b);" & _
            "}" & _
            name & ".value=a.getDate()+'/'+(a.getMonth()+1)+'/'+a.getFullYear()" & _
            "}"">"
    End sub

End Class
%>