<%
Class CStrings

    Private Sub Class_Initialize
    
    End Sub
    
    Private Sub Class_Terminate
    
    End Sub
    
    Public Default Property Get DefaultProperty
        DefaultProperty = typename(Me)
    End Property
    
    ' Fonction qui met en majuscule la premire lettre de tous les mots d'une chaine de caractres (utile pour les prnoms)
    Public Function ToProperCase(s)
        Dim propercase
        Dim Arr()
        Dim i

        If len(trim(s)) > 0 Then
            ReDim Arr(0)
            
            For i = 1 to len(s)
                If IsAlpha(mid(s, i, 1)) = true Then
                    Arr(ubound(Arr)) = Arr(ubound(Arr)) & mid(s, i, 1)
                else
                    ReDim Preserve Arr(ubound(Arr) + 1)
                    Arr(ubound(Arr)) = mid(s, i, 1)
                    ReDim Preserve Arr(ubound(Arr) + 1)
                End If
            Next
            
            For i = 0 to ubound(Arr)
                If len(Arr(i)) > 1 Then
                    propercase = propercase & UCase(Left(Arr(i),1)) & LCase(mid(Arr(i),2,len(Arr(i))-1))
                Else
                    propercase = propercase & Arr(i)
                End If
            Next
        else
            propercase = ""
        End If

        ToProperCase = propercase
    End Function
    
    ' Fonction permettant de determiner si un caractre est une lettre
    Public Function IsAlpha(c)
        If (asc(c) > 64 and asc(c) < 91) or (asc(c) > 96 and asc(c) < 123) or (asc(c) > 191 and asc(c) < 256) Then
            IsAlpha = true
        else
            IsAlpha = False
        End If
    End Function

    ' Procdure permettant d'afficher les caractres ascii dans diffrents types d'encodage
    Public Sub DisplayAscii
        Dim i
        Response.Write "" & vbcrlf & _
            "<table align=""center"" cellpadding=""3"">" & vbcrlf & _
            "    <tr>" & vbcrlf & _
            "    <th>&nbsp;</th>" & vbcrlf & _
            "    <th>Ascii<br />Chr(i)</th>" & vbcrlf & _
            "    <th>HTML<br />replace(server.HTMLEncode(Chr(i)),""&"",""&amp;amp;"")</th>" & vbcrlf & _
            "    <th>URL<br />server.URLEncode(Chr(i))</th>" & vbcrlf & _
            "    <th>HEX<br />""&amp;H"" & hex(i)</th>" & vbcrlf & _
            "    <th>OCT<br />oct(i)</th>" & vbcrlf & _
            "</tr>" & vbcrlf & _
            "<tbody>" & vbcrlf
            FOR i = 1 to 255
                If i mod 2 = 0 Then
                    response.Write("<tr class=""even"">") & vbcrlf
                else  
                    response.Write("<tr class=""odd"">") & vbcrlf
                End If
                response.Write("   <td align=""left"" valign=""top"" nowrap>Chr(" & i &")</td>" & vbcrlf & _
                    "   <td align=""center"" valign=""top"" nowrap>" & Chr(i) & "</td>" & vbcrlf & _
                    "   <td align=""center"" valign=""top"" nowrap>" & replace(server.HTMLEncode(Chr(i)),"&","&amp;") & "</td>" & vbcrlf & _
                    "   <td align=""center"" valign=""top"" nowrap>" & server.URLEncode(Chr(i)) & "</td>" & vbcrlf & _
                    "   <td align=""center"" valign=""top"" nowrap>" & "&amp;H" & hex(i) & "</td>" & vbcrlf & _
                    "   <td align=""right"" valign=""top"" nowrap>" & oct(i) & "</td>" & vbcrlf & _
                    "</tr>" & vbcrlf)
            NEXT
        Response.Write "    </tbody>" & vbcrlf & _
            "</table>" & vbcrlf
    End Sub
    
    Public Function ActivateHttp(str)
        Dim oRegEx
        Set oRegEx = New RegExp
            With oRegEx
                .Pattern = "((https?|ftp|gopher|telnet|file|notes|ms-help):((//)|(\\\\))+[\w\d:#@%/;$()~_?\+-=\\\.&]*)"
                .IgnoreCase = True
                .Global = True
            End With
            str = oRegEx.Replace(str, "<a href=""$1"">$1</a>")
            ActivateHttp = str
        Set oRegEx = nothing
    End Function
    
    ' encodage des textes pour le javaScript
    '+-------------------------------------------------------
    Public Function JsEncode(pString)
        If pString = "" Then
            JsEncode = ""
        else
            JsEncode = replace(replace(Replace(Replace(pString,"'","\'"),"""","\'"), vbcrlf, ""), vbtab, "")
        End If
    End Function
    
    ' gestion des pluriels, rgle simple : ajout du 's'
    ' ne gre pas : les mots composs, les pluriels en 'x', les mots en 'ail' ou 'al'
    '+-------------------------------------------------------
    Public Function Plural(pChaine, pNb)
        If pChaine = "" Then
            Plural = pChaine
        else
            If cLng(pNb) > 1 Then
                Plural = pChaine & "s"
            else
                Plural = pChaine
            End If
        End If
    End Function
    
    ' texte alatoire, pas de confusion entre le chiffre 0 et la lettre O
    '+-------------------------------------------------------
    Public Function RandomString(nbCar)
        Dim vocab, temp, i
        vocab = "AZERTYUIOPMLKJHGFDSQWXVCBN123456789azertyuiopqsdfghjklmwxcvbn"
        temp = ""
        randomize
        For i = 1 to nbCar
            temp = temp & Mid(vocab, rnd() * len(vocab) + 1, 1)
        Next 
        RandomString = temp
    End Function
    
    ' suppression de tous les TAGS HTML
    '+-------------------------------------------------------
    Public Function NoHtmlTag(pTexte)
        'on supprime les tags HTML
        Dim regEx
        Dim pTxt
        pTxt = Globals.DefaultValue(pTexte, "")
        pTxt = replace(pTxt, "*", "&")    
        pTxt = replace(pTxt, "&bull;", "-")    
        pTxt = replace(pTxt, "&laquo;", """")    
        pTxt = replace(pTxt, "&raquo;", """")    
        pTxt = replace(pTxt, "&quot;", """")    
        pTxt = replace(pTxt, "&deg;", "")    
        pTxt = replace(pTxt, "&copy;", "(c)")    
        pTxt = replace(pTxt, "&reg;", "(R)")    
        pTxt = replace(pTxt, "&rsquo;", "'")    
        pTxt = replace(pTxt, "&#61623;", "-")
        pTxt = replace(pTxt, "&ndash;", "-")
        pTxt = replace(pTxt, "&hellip;", "...")
        pTxt = replace(pTxt, "&nbsp;", " ")
        pTxt = replace(pTxt, "", "oe")
        pTxt = replace(pTxt, "&oelig;", "oe")
        pTxt = replace(pTxt, "&eacute;", "")
        pTxt = replace(pTxt, "&egrave;", "")
        pTxt = replace(pTxt, "&ecirc;", "")
        pTxt = replace(pTxt, "&euml;", "")
        pTxt = replace(pTxt, "&OElig;", "OE")
        pTxt = replace(pTxt, "&Eacute;", "E")
        pTxt = replace(pTxt, "&Egrave;", "E")
        pTxt = replace(pTxt, "&Ecirc;", "E")
        pTxt = replace(pTxt, "&Euml;", "E")
        pTxt = replace(pTxt, "&agrave;", "")
        pTxt = replace(pTxt, "&acirc;", "")
        pTxt = replace(pTxt, "&Agrave;", "A")
        pTxt = replace(pTxt, "&Acirc;", "A")
        pTxt = replace(pTxt, "&ugrave;", "")
        pTxt = replace(pTxt, "&ucirc;", "")
        pTxt = replace(pTxt, "&uuml;", "")
        pTxt = replace(pTxt, "&Ugrave;", "U")
        pTxt = replace(pTxt, "&Uuml;", "U")
        pTxt = replace(pTxt, "&icirc;", "")
        pTxt = replace(pTxt, "&iuml;", "")
        pTxt = replace(pTxt, "&Iuml;", "")
        pTxt = replace(pTxt, "&ocirc;", "")
        pTxt = replace(pTxt, "&ccedil;", "")
        pTxt = replace(pTxt, "&Ccedil;", "C")
        pTxt = replace(pTxt, "&euro;", "")
        pTxt = replace(pTxt, "&", "*")        
        pTxt = replace(pTxt, "<br>", " ")
        pTxt = replace(pTxt, vbcrlf, " ")
        pTxt = replace(pTxt, vbTab, "")
        pTxt = replace(pTxt, "", "'")
        pTxt = replace(pTxt, "", "'")    'diffrent du prcdent ...
        pTxt = replace(pTxt, """", "'")
        pTxt = replace(pTxt, "", "'")
        pTxt = replace(pTxt, "", "'")
        pTxt = replace(pTxt, "", "-")
        pTxt = replace(pTxt, "", "-")
        pTxt = replace(pTxt, "", "...")
        Set regEx = New RegExp
        regEx.Global = True
        regEx.Pattern = "<[^>]+>"
        NoHtmlTag = regEx.replace(pTxt,"")
        set regEx = nothing
        'on s'occupe des artefacts
        NoHtmlTag = replace(NoHtmlTag, "<", "")
        NoHtmlTag = replace(NoHtmlTag, ">", "")
    End Function
    
    ' que des lettres et des chiffres (on enlve tout le reste) 
    '+-------------------------------------------------------
    Public Function OnlyLettersAndNumbers(pTxt)
        Dim pAllowed, pNum, pTemp
        pAllowed = "/0123456789abcdefghijklmnopqrstuvwxyz"
        pTemp = ""
        For i = 1 To len(pTxt)
            If InStr(pAllowed, LCase(Mid(pTxt, i, 1))) <> 0 Then
                pTemp = pTemp & Mid(pTxt, i, 1)
            Else
                pTemp = pTemp & " "
            End If
        Next
        OnlyLettersAndNumbers = pTemp
    End Function
    
    ' on limite une chaine de caractres  un certain nombre de mots
    '+-------------------------------------------------------
    Public Function PremiersMots(pTxt, pNum)
        Dim pRank, txt_temp, txt_splitted
        'on commence par enlever les tags HTML
        txt_temp = NoHtmlTag(pTxt)
        'on supprime tout ce qui n'est pas lettre et chiffre
        txt_temp = OnlyLettersAndNumbers(txt_temp)
        txt_temp = replace(txt_temp, "  ", " ")    'pour grer les doubles espaces (', ' devenu '  ' par exemple)
        txt_temp = replace(txt_temp, "  ", " ")    'pour grer les triples espaces (' : ' devenu '   ' par exemple)
        txt_splitted = split(txt_temp, " ")
        For pRank = 1 to min(ubound(txt_splitted)+1, cLng(gNumbers.toZero(pNum)))
            PremiersMots = PremiersMots & txt_splitted(pRank - 1) & " " 
        Next
        If ubound(txt_splitted) > cLng(gNumbers.toZero(pNum)) Then
            PremiersMots = PremiersMots & "..."
        End If
    End Function
    
    ' formatage des numros de tlphone : 01 64 99 22 00
    '+-------------------------------------------------------
    Public Function FormatPhoneNumber(pNum)
        Dim unWantedChar, tempNumber, c
        unWantedChar = " .,/?*-+azertyuiopqsdfghjklmwxcvbn"
        If not isnull(pNum) and pNum <> "" Then
            tempNumber = pNum
            For c = 1 to len(unWantedChar)
                'on supprime les caractres non dsirs
                tempNumber = replace(tempNumber, mid(unWantedChar, c, 1), "")
                If len(tempNumber) = 10 Then
                    FormatPhoneNumber = mid(tempNumber, 1, 2) & " " & mid(tempNumber, 3, 2) & " " & mid(tempNumber, 5, 2) & " " & mid(tempNumber, 7, 2) & " " & mid(tempNumber, 9, 2) 
                else
                    'pas 10 chiffres ?
                    FormatPhoneNumber = pNum
                End If
            Next
        else
            FormatPhoneNumber = ""
        End If
    End Function
    
End Class

 %>