<% option explicit %>

<!--#include file="cls_Application.asp" -->
<!--#include file="cls_HttpContext.asp" -->
<!--#include file="cls_DBFactory.asp" -->
<!--#include file="cls_File.asp" -->
<!--#include file="cls_Number.asp" -->
<!--#include file="cls_Date.asp" -->
<!--#include file="cls_String.asp" -->
<!--#include file="cls_Form.asp" -->
<!--#include file="cls_Security.asp" -->
<!--#include file="cls_Collection.asp" -->
<!--#include file="cls_Debug.asp" -->
<!--#include file="cls_Encryption.asp" -->
<!--#include file="cls_Email.asp" -->
<!--#include file="cls_Global.asp" -->

<%
' objets globaux utiliss dans les classes ou le code
Dim Globals, Debug
Set Globals = New CGlobal
Set Debug = Globals.Debug

' Class runissant des outils
Class System
    Private m_Http
    Private m_BD
    Private m_Numbers
    Private m_Dates
    Private m_Strings
    Private m_File
    Private m_Forms
    Private m_Security
    Private m_Encryption
    Private m_Collection
    Private m_Appl
    Private m_Email
    
    Private Sub Class_Initialize
        Set m_Http = Nothing
        Set m_BD = Nothing
        Set m_Numbers = Nothing
        Set m_Dates = Nothing
        Set m_Strings = Nothing
        Set m_File = Nothing
        Set m_Forms = Nothing
        Set m_Security = Nothing
        Set m_Encryption = Nothing
        Set m_Collection = Nothing
        Set m_Appl = Nothing
        Set m_Email = nothing
    End Sub
    
    Private Sub Class_Terminate
        Set m_Email = nothing
        Set m_Appl = Nothing
        Set m_Collection = Nothing
        Set m_Encryption = Nothing
        Set m_Security = Nothing
        Set m_Forms = Nothing
        Set m_File = Nothing
        Set m_Strings = Nothing
        Set m_Dates = Nothing
        Set m_Numbers = Nothing
        Set m_BD = Nothing
        Set m_Http = Nothing
    End Sub
    
    Public Default Property Get DefaultProperty
        DefaultProperty = typename(Me)
    End Property
    
    Public Property Get MapPath(path)
        MapPath = Server.MapPath(path)
    End Property

    Public Property Get Http
        If m_Http Is Nothing Then
            Set m_Http = New HttpContext
        End If
        Set Http = m_Http
    End Property
    
    Public Property Get BD
        If m_BD Is Nothing Then
            Set m_BD = New DBFactory
        End If
        Set BD = m_BD
    End Property
    
    Public Property Get Numbers
        If m_Numbers Is Nothing Then
            Set m_Numbers = New CNumbers
        End If
        Set Numbers = m_Numbers
    End Property
    
    Public Property Get Dates
        If m_Dates Is Nothing Then
            Set m_Dates = New CDatesTime
        End If
        Set Dates = m_Dates
    End Property

    Public Property Get Strings
        If m_Strings Is Nothing Then
            Set m_Strings = New CStrings
        End If
        Set Strings = m_Strings
    End Property
    
    Public Property Get Files
        If m_File Is Nothing Then
            Set m_File = New CFile
        End If
        Set Files = m_File 
    End Property

    Public Property Get Forms
        If m_Forms Is Nothing Then
            Set m_Forms = New CForms
            Set m_Forms.BD = BD
        End If
        Set Forms = m_Forms 
    End Property

    Public Property Get Security
        If m_Security Is Nothing Then
            Set m_Security = New CSecurity
        End If
        Set Security = m_Security 
    End Property

    Public Property Get Encryption
        If m_Encryption Is Nothing Then
            Set m_Encryption = New CEncryption
        End If
        Set Encryption = m_Encryption 
    End Property
    
    Public Property Get Collection
        If m_Collection Is Nothing Then
            Set m_Collection = New CCollection
        End If
        Set Collection = m_Collection 
    End Property
    
    Public Property Get Application
        If m_Appl Is Nothing Then
            Set m_Appl = New CApplication
        End If
        Set Application = m_Appl 
    End Property
    
    Public Property Get Email
        If m_Email Is Nothing Then
            Set m_Email = New CEmail
        End If
        Set Email = m_Email 
    End Property

End Class
%>