<%@  language="VBSCRIPT" codepage="1252" %>
<!--#include file="cls_System.asp" -->
<%
Call Main(Request.Form)

Sub Main(frm)
    Call ProcessForm(frm)
    Call DisplayForm(frm)
End Sub

Public Sub ProcessForm(frm)
    if len(frm) > 0 then
        Session.Contents.Remove("code")
        Session.Contents.Remove("sql")
        Session.Contents.Remove("rst")
        if frm("code") = 1 then
            Session.Contents.Item("code") = frm("code")
        else
        end if
        if frm("sql") = 1 then
            Session.Contents.Item("sql") = frm("sql")
        else
        end if
        if frm("rst") = 1 then
            Session.Contents.Item("rst") = frm("rst")
        else
        end if
    end if
End Sub

Sub ProcessTest(frm)
    Dim fw, tmp
    Response.Write "Testing Default properties of istanciated classes<br />" : Response.Flush
    Response.Write "<hr />"
    Response.Write "Get " & Globals & ": Passed<br />" : Response.Flush
    Response.Write "Get " & Debug & ": Passed<br />" : Response.Flush
    Response.Write "<hr />"
    Set fw = New System
    Response.Write fw & ": Passed<br />" : Response.Flush
    Response.Write fw & ".MapPath(""."") = " & fw.MapPath(".") & ": Passed<br />" : Response.Flush
    Response.Write fw & "." & fw.Application & ": Passed<br />" : Response.Flush
    Response.Write fw & "." & fw.Collection & ": Passed<br />" : Response.Flush
    Response.Write fw & "." & fw.BD & ": Passed<br />" : Response.Flush
    Response.Write fw & "." & fw.Dates & ": Passed<br />" : Response.Flush
    Response.Write fw & "." & fw.Email & ": Passed<br />" : Response.Flush
    Response.Write fw & "." & fw.Encryption & ": Passed<br />" : Response.Flush
    Response.Write fw & "." & fw.Files & ": Passed<br />" : Response.Flush
    Response.Write fw & "." & fw.Forms & ": Passed<br />" : Response.Flush
    Response.Write fw & "." & fw.Http & ": Passed<br />" : Response.Flush
    Response.Write fw & "." & fw.Numbers & ": Passed<br />" : Response.Flush
    Response.Write fw & "." & fw.Security & ": Passed<br />" : Response.Flush
    Response.Write fw & "." & fw.Strings & ": Passed<br />" : Response.Flush
    Response.Write "<hr />"
    fw.BD.Provider = Application("ConnectionString")
    Response.Write "Let " & fw & "." & typename(fw.BD) & ".Provider(" & Application("ConnectionString") & "): Passed<br />" : Response.Flush
End Sub

Sub DisplayForm(frm)
%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>ASP 3.0 FrameWork - Console de contrle</title>
    <style type="text/css">
        body
        {
            font-family:Arial;
            font-size:10pt;
            margin: 10px;
        }
        table
        {
            border-collapse:collapse;
            border: solid 1px black;
            font-size:1em;
            width: 200px;
        }
        th
        {
            background-color:Silver;
            border: solid 1px black;
            font-size:1em;
            font-weight:bold;
        }
        td
        {
            border: solid 1px black;
            font-size:1em;
        }
    </style>
</head>
<body style="">
    <form action="" id="frm" method="post">
        <input type="hidden" id="test" name="test" value="1" />
        <div style="text-align: center">
            <p>
                Utiliser cette page pour modifier le comportement du FrameWork.</p>
            <table>
                <thead>
                    <tr>
                        <th colspan="2">
                            Debug</th>
                    </tr>
                </thead>
                <tbody>
                    <tr>
                        <td>
                            Show class code</td>
                        <td>
                            <input id="code" <%if len(Session.Contents.Item("code")) > 0 then response.write("checked")%>
                                name="code" type="checkbox" value="1" onclick="submit(this)" /></td>
                    </tr>
                    <tr>
                        <td>
                            Debug SQL Query</td>
                        <td>
                            <input id="sql" <%if len(Session.Contents.Item("sql")) > 0 then response.write("checked")%>
                                name="sql" type="checkbox" value="1" onclick="submit(this)" /></td>
                    </tr>
                    <tr>
                        <td>
                            Debug Recordset</td>
                        <td>
                            <input id="rst" <%if len(Session.Contents.Item("rst")) > 0 then response.write("checked")%>
                                name="rst" type="checkbox" value="1" onclick="submit(this)" /></td>
                    </tr>
                    <tr>
                        <td>
                            Test FW</td>
                        <td>
                            <input type="submit" name="Action" value="Test" /></td>
                    </tr>
                </tbody>
            </table>
        </div>
    </form>
<%
    if lcase(left(frm("Action"), 4)) = "test" then
        ProcessTest(frm)
    else
    end if
%>

</body>
</html>
<%
End Sub
%>
