<%
Option explicit

Dim m_xml
Set m_xml = new CXml
    m_xml.Load(Server.MapPath("../web.config"))
    'm_xml.Load(Server.MapPath("../xmlfile.xml"))
Set m_xml = Nothing

Class CXml

    Private m_xml
    
    Private Sub Class_Initialize
        Set Xml = Server.CreateObject("microsoft.xmldom")
    End Sub
    
    Private Sub Class_Terminate
        Set m_xml = Nothing
    End Sub
    
    Public Default Property Get DefaultProperty
        DefaultProperty = typename(Me)
    End Property
    
    Public Property Set Xml(obj)
        Set m_xml = obj
    End Property
    Public Property Get Xml
        Set Xml = m_xml
    End Property
    
    Public Sub Load(path)
        Dim objXML, Nodes

        Xml.Load(path)
        
        Set Nodes = Xml.documentElement.childNodes
        call DisplayNodes(Nodes, 0)
    End Sub
    
    Function Spaces(indent)
        Dim i
        for i = 0 to indent
            Spaces = Spaces & "&nbsp;"
        next
    End function

    Public Sub DisplayNodes(Nodes, byval indent)
        Dim node, att
        
        for each node in Nodes
            Response.Write Spaces(indent)
            
            select case node.nodeType
                case 3
                    Response.Write node.nodeValue & vbcrlf & "<br />"
                case 8
                    ' commentaire
                    Response.Write node.nodeName & " " & node.nodeValue
                case 1
                    Response.Write "<span style = ""color : red;"">&lt;<span style = ""color : brown;"">" & node.nodeName & "</span>"
                    if not isnull(node.attributes) and node.nodeType <> 8 then
                        for each att in node.attributes
                            Response.Write " <span style = ""color : brown;"">" & _
                                att.name & "&nbsp;=</span>&nbsp;""<span style = ""color : black; font-weight: bold;"">" & att.value & "</span>"""
                        next
                    end if
                    Response.Write "&gt;</span>" & vbcrlf & "<br />"
                    
                case else
                    Response.Write node.nodeType & " " & node.attributes.Length
            end select
            
            If node.hasChildNodes Then
                DisplayNodes node.childNodes, indent + 4
            End If
            
            'Response.Write Spaces(indent) & "<span style = ""color : red;"">&lt;/<span style = ""color : brown;"">" & node.nodeName & "&gt;</span></span>" & vbcrlf & "<br />"
        Next
    End Sub

End Class

 %>